/*
 Ali Nouri Zonoz   CMU
 July 2018

 */

 #ifdef __linux__
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#elif defined(_WIN32) || defined(_WIN64)

#endif

 #include <iostream>

#include "dynamixel_sdk/dynamixel_sdk.h"  
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <thread>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <fstream>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <stdint.h>
#include <netinet/in.h>
#include <time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <iostream>
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/opencv.hpp"
#include "opencv2/video.hpp"
#include "opencv2/highgui.hpp"
#include <vector>
#include <atomic>
#define BUFSIZE 	200
#define NUM_THREADS   11

#define SERVERPORT   "30313"
#define SERVERPORTARD "2390"
#define THRESH                        20

#define ADDR_MX_TORQUE_ENABLE           24                  // Control table address is different in Dynamixel model
#define ADDR_MX_GOAL_POSITION           30
#define ADDR_MX_PRESENT_POSITION        36

// Protocol version
#define PROTOCOL_VERSION                1.0                 // See which protocol version is used in the Dynamixel

// Default setting
#define DXL_ID                          1                // Dynamixel ID: 1
#define DXL_IDD                          2                // Dynamixel ID: 1
#define DXL_LID                          3                // Dynamixel ID: 1
#define DXL_LIDD                          4                // Dynamixel ID: 1
#define BAUDRATE                        2000000
#define DEVICENAME                      "/dev/ttyUSB0"      // Check which port is being used on your controller
                                                            // ex) Windows: "COM1"   Linux: "/dev/ttyUSB0"
#define LEN_MX_GOAL_POSITION            2
#define LEN_MX_PRESENT_POSITION         2
#define TORQUE_ENABLE                   1                   // Value for enabling the torque
#define TORQUE_DISABLE                  0                   // Value for disabling the torque
#define DXL_MINIMUM_POSITION_VALUE      100                 // Dynamixel will rotate between this value
#define DXL_MAXIMUM_POSITION_VALUE      4000                // and this value (note that the Dynamixel would not move when the position value is out of movable range. Check e-manual about the range of the Dynamixel you use.)
#define DXL_MOVING_STATUS_THRESHOLD     10                  // Dynamixel moving status threshold

#define ESC_ASCII_VALUE                 0x1b


using namespace cv;
using namespace std;

//********************************************************************************************* Defining Global Variables ******************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
std::atomic<bool> go0;
std::atomic <bool> go1;
std::atomic <bool> go2;
std::atomic <bool> go3;
std::atomic <bool> go4;
std::atomic <bool> go5;
std::atomic <bool> LEDON;


int MAXARDNUM;
int  closeupA=0;
int  closeupB=0;
int closeuplens=0;
int capcon=0;
Mat IMG,IMG2;
string dataname;
int closeupimg=0;
int liveimg=0;
int click=0;
int reward=0;
Mat imgtmp;

Mat mC=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mD=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mA=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mB=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mE=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mF=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);

//Input: Distortion Coefficients
Mat dA=(Mat_<float>(1,4) << -3.3578247297666314e-01, 2.2743674110178400e-01, 0, 0);// -2.3704722217306959e+00);//-8.8204262039829340e-01
//Mat dA=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);
Mat dB=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);
Mat dC=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);
Mat dD=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);
Mat dE=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);
Mat dF=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);

Mat M1= (Mat_<float>(3,4)<<1, 0, 0, 0, 0, 1, 0, 0,0, 0, 1, 0);
Mat M2= (Mat_<float>(3,4)<<-0.545004189, 0.836235583, 0.0606667623, 0.0977601334, -0.770429194, -0.52803266 ,0.357239932 ,-0.994968414 ,0.330770761 ,0.147957802 ,0.932040334 ,-0.021928696  );
Mat M3= (Mat_<float>(3,4)<<0.137240127, 0.784169376, -0.605180621 ,1.59032071, -0.813773155 ,0.4375934 ,0.382472605 ,-0.941307902 ,0.56474632 ,0.43998912 ,0.698191345, 0.701788187    );
Mat M4= (Mat_<float>(3,4)<<-0.160119459, -0.66468966, 0.729759812, -2.57506323, 0.700145721, 0.444661438 ,0.558634222 ,-1.9803431, -0.695814431, 0.600386441, 0.394180685 ,2.33730888    );
Mat M5= (Mat_<float>(3,4)<<0.957975268, 0.269619763, -0.0979212075, 0.0839340985, -0.107529148, 0.0210617259, -0.993978798, 2.94537807, -0.265933931, 0.962736487, 0.0491685942, 3.27126098   );
Mat M6= (Mat_<float>(3,4)<<0.967009068 , 0.250047743 , -0.0486789085 , -0.53317374 , -0.0469203107 , -0.0129927909 , -0.998814106 , 3.10142016 , -0.250383705 , 0.968146324 , -0.000831828336 , 3.91923642  );
//Mats for Rotation,Transition and Mask Matrix


//Mat output of Triangulation

Point3f output3d;
Mat P4D(4,1,CV_32FC1, Scalar::all(0));
Mat P4Dreal(3,1,CV_32FC1, Scalar::all(0));
Mat dst,src;
//Integers and others..
int globalplot=0;
int liveshow=0;							//gnuplot starting
int row=0;							//control for data collection
int done=0;        						//control of stopping gnuplot
int posX2,posY2,posX1,posY1,posY3,posX3,posX4,posY4,posY5,posX5,posX6,posY6;
int T1,T2,T3,T4;							//2D positions received from both cameras
int iLastX1,iLastX2,iLastY1,iLastY2,iLastY3,iLastX3;				//Values for 2D drawing
//float w; 							//PD4
double focal = mA.at<float>(0,0); 				// focal length
Point2d pp(mA.at<float>(0,2), mA.at<float>(1,2)); 		//principal point
int neural=0;
int neocond=1;
int ms;
int mspast;
int counttwo=0;
Point3f POSred,POSFED1,Mouse,prePOSred;
Point3f ConPlace;
struct timeval tp1,tp2,tp3,tp4,tp5,tp6,tj1,tj2,tpnow,tpprev,tpf1,tpf2,tpFED1,tpFED2,tpSignal,tpJCH;
int CKL=0;
int deliver=0;
Mat mylivecam;

//Mat res(200, 400,CV_8UC1, Scalar::all(0));
 Mat3b res(200, 400, Vec3b(0,0,0));
int S=0;
vector<cv::Point3f> first, second;
std::vector<uchar> inliers;
//cv::Mat aff(3,4,CV_64F);


Mat aff = (Mat_<float>(3,4)<<-52.038147, -39.6383247, 28.0614681, -53.7734871 ,-47.3325119, 37.8025208, -36.8359337 ,143.201675 ,6.00589037 ,-44.9202881, -55.1307335 ,224.91893 );


// File to write the 3d positions
ofstream myfile;
ofstream Signaling;
ofstream myFplot;
ofstream timeandpos;
ofstream dot;
ofstream plotingdata;
ofstream samplee;
float Distance=100;
int countt=0;
// Vectors for storing the collected data used in recoverpose and find essentialMat function
vector<Point2f> objectPointsA, objectPointsAA;
vector<Point2f> objectPointsB, objectPointsBB;
vector<Point2f> objectPointsC, objectPointsCC;
vector<Point2f> objectPointsD, objectPointsDD;
vector<Point2f> objectPointsE, objectPointsEE;
vector<Point2f> objectPointsF, objectPointsFF;

//VideoCapture cap(CV_CAP_XIAPI);
//Vectors for single points inside the Triangulation loop - for Onlien tracking
vector<Point2f> objA(1);
vector<Point2f> objB(1);
vector<Point2f> objC(1);
vector<Point2f> objD(1);
vector<Point2f> objE(1);
vector<Point2f> objF(1);
vector<Point2f> objA_undist(1);
vector<Point2f> objB_undist(1);
vector<Point2f> objC_undist(1);
vector<Point2f> objD_undist(1);
vector<Point2f> objE_undist(1);
vector<Point2f> objF_undist(1);

vector<Point3f> FEDPOS;

vector<Mat> projMatr (6);
Mat imgcap,imgcap2,dst2;
int Mstate=0;
Mat imgreal;
FILE *file;
float FFF;
ofstream latency;

Size size(200,200);
Size size2(640,512);

float X,Y,Z=0;
float x=0.0;
float y=0.0;
float z=0.0;
float AA=0.0;
float BB=0.0;
float CC=0.0;
float A=0.0;
int AF=0.0;
int inA=0.0;
float B=0.0;
int BF=0.0;
int inB=0.0;
int AF2=0;
float CC2=0.0;
float A2=0.0;
float AA2=0.0;
float OFD=0.0; 
float GG;
float focus=0;
float shit;
float shit2;
float B2=0.0;
int BF2=0.0;
float BB2=0.0;
int starttr=0;
int ms_speed=0;
Mat img;Mat bb;
int con=0;
//int reward=0;
//int click=0;
int dxl_comm_result = COMM_TX_FAIL;             // Communication result
int dxl_comm_result2 = COMM_TX_FAIL;
uint8_t dxl_error = 0;                          // Dynamixel error
uint16_t dxl_present_position = 0;
uint8_t param_goal_position[2];
uint8_t param_goal_position2[2];
uint8_t param_goal_Lposition[2];
uint8_t param_goal_Lposition2[2];
bool dxl_addparam_result = false;  
dynamixel::PortHandler *portHandler = dynamixel::PortHandler::getPortHandler(DEVICENAME);
dynamixel::PacketHandler *packetHandler = dynamixel::PacketHandler::getPacketHandler(PROTOCOL_VERSION);
dynamixel::GroupSyncWrite groupSyncWrite(portHandler, packetHandler, ADDR_MX_GOAL_POSITION, LEN_MX_GOAL_POSITION);
string floc;
int ManualARDNUM=0;	
int goARD=0;	
int TT=2;
int Freq=9;
string freq;
string tt;
	
vector <int> WIFLOW;
		
		//FILE *file;
//Mat X;
//********************************************************************************************* Functions **********************************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
//******************************************************************************************************************************************************************************************************************//

void CallBackFunc(int event, int x, int y, int flags, void* userdata)
{
    if  ( event == EVENT_LBUTTONDOWN )
    {
    	goARD=0;
        //cout << "Left button of the mouse is clicked - position (" << x << ", " << y << ")" << endl;
        if(x<149 & x>19){
        	ManualARDNUM=1;
			int XX=19;
			int YY;
			if(y>81 & y<139)
			{
				YY=81;
				con=1;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
				
			}
			if(y>148 & y<207)
			{
				YY=148;
				con=2;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>216 & y<274)
			{
				YY=216;
				con=3;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>284& y<342)
			{
				YY=284;
				con=4;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>352& y<409)
			{
				YY=352;
				con=5;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>419& y<477)
			{
				YY=419;
				con=6;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
		
	}
	 if(x>223 & x<354)
	 {
	 		ManualARDNUM=2;
			int XX=223;
			int YY;
			if(y>81 & y<139)
			{
				YY=81;
				con=1;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
				
			}
			if(y>148 & y<207)
			{
				YY=148;
				con=2;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>216 & y<274)
			{
				YY=216;
				con=3;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>284& y<342)
			{
				YY=284;
				con=4;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>352& y<409)
			{
				YY=352;
				con=5;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>419& y<477)
			{
				YY=419;
				con=6;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
	 
	 }
	 
	 
	 if(x>423 & x<554)
	 {
	 		ManualARDNUM=3;
			int XX=423;
			int YY;
			if(y>81 & y<139)
			{
				YY=81;
				con=1;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
				
			}
			if(y>148 & y<207)
			{
				YY=148;
				con=2;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>216 & y<274)
			{
				YY=216;
				con=3;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>284& y<342)
			{
				YY=284;
				con=4;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>352& y<409)
			{
				YY=352;
				con=5;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>419& y<477)
			{
				YY=419;
				con=6;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
	 }
	 if(x>631 & x<760)
	 {
			ManualARDNUM=4;
			int XX=631;
			int YY;
			if(y>81 & y<139)
			{
				YY=81;
				con=1;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
				
			}
			if(y>148 & y<207)
			{
				YY=148;
				con=2;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>216 & y<274)
			{
				YY=216;
				con=3;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>284& y<342)
			{
				YY=284;
				con=4;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>352& y<409)
			{
				YY=352;
				con=5;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
			if(y>419& y<477)
			{
				YY=419;
				con=6;
				rectangle(img, Rect (XX,YY,130,58), Scalar(0, 0, 0),4);
			}
	 }
	 

    }
    else if  ( event == EVENT_RBUTTONDOWN )
    {
        cout << "Right button of the mouse is clicked - position (" << x << ", " << y << ")" << endl;
        
    }
    else if  ( event == EVENT_MBUTTONDOWN )
    {
        cout << "Middle button of the mouse is clicked - position (" << x << ", " << y << ")" << endl;
    }
    else if ( event == EVENT_MOUSEMOVE )
    {
        //cout << "Mouse move over the window - position (" << x << ", " << y << ")" << endl;
    }
   else if (event == EVENT_LBUTTONUP)
    {
    	bb.copyTo(img);
    }
        
}




float calcdist(cv::Point3f A, cv::Point3f B)
{
	float Dist=float ( sqrt (  (A.x-B.x)*(A.x-B.x) +  (A.y-B.y)*(A.y-B.y) + (A.z-B.z)*(A.z-B.z)     ) );
	return Dist;
}
float calcdist2D(cv::Point3f A, cv::Point3f B)
{
 float Dist =sqrt (  (A.x-B.x)*(A.x-B.x) +  (A.y-B.y)*(A.y-B.y));
 return Dist;
}
void set_realtime_priority()
{
	int ret;
	pthread_t this_thread=pthread_self();
	struct sched_param params;
	params.sched_priority=sched_get_priority_max(SCHED_FIFO);
	ret=pthread_setschedparam(this_thread,SCHED_FIFO,&params);
}
int Triangulate(const vector<Mat> projMatr, const vector<int> index, const vector<Point2f> projPoints, Mat& X)
{
/* parameters
   - projMatr : list of all 3x4 camera matrices
   - index : list of cam numbers corresponding to projections
   - projPoints : list of 2D image projections
   - points3D : triangulated 3D point (output)
*/

    // Check if enough views to triangulate
    int nviews=index.size();
    if (nviews<2) return(0);

    Mat A, P, r;
    float x,y;

    // Fill matrix A
    for( int j = 0; j < nviews; j++ ) {

     // get image projection
     x = (float) projPoints[j].x;
     y = (float) projPoints[j].y;

     // get corresponding cam matrix
     P = projMatr[index[j]];

     // add 3 lines to A (cf HZ book chap 12.2 p312)reference camera with more tha 2 views 3d
     r = P.row(2)*x - P.row(0); A.push_back(r);
     r = P.row(2)*y - P.row(1); A.push_back(r);
   // r = x*P.row(1) - y*P.row(0);  A.push_back(r); // redundant
    }

    // Solve homogenous system AX=0 with |X|=1, using Singular Value Decomposition
    // ref  Hartley&Zissermann book p592
    SVD::solveZ(A, X);

    // Perform reweighting and iterate solving to increase accuracy
    // ref Hartley&Sturm 1997 paper "Triangulation", Iterative-Eigen method
   float w;
    for (int c=0; c<5; c++) { // iterate 5 times
         for( int j = 0; j < nviews; j++ ) {
         int i=2*j;
         r = projMatr[index[j]].row(2)*X;
         w=r.at<float>(0);
         if (abs(w)<1e-6) break;
         w=1/w;
         r=A.row(i); A.row(i)=r*w;
         r=A.row(i+1); A.row(i+1)=r*w;
         }
         SVD::solveZ(A, X);
    }
	//cout<<X<<endl<<endl<<endl;
    if (!checkRange(X) || X.at<float>(3)==0) {
    cout << "SVD algorithm error" << endl;
     return(0);
    }
    else {
    // return real (inhomogeneous) 3D point
     X.at<float>(0) = X.at<float>(0) / X.at<float>(3);
     X.at<float>(1) = X.at<float>(1) / X.at<float>(3);
     X.at<float>(2) = X.at<float>(2) / X.at<float>(3);
     X.at<float>(3) = X.at<float>(3) / X.at<float>(3);
    }

    return(1);
}
//Error function for UDP
void error(char *msg) {
  perror(msg);
  exit(1);
}








//Thread function
void *Track(void *threadid)
 {
    long tid;
    tid = (long)threadid;






    if(tid==0){
    
   	 	while(globalplot==0)
		{}
		//while(1){}
		system(" ./dirplot.sh -e");
	
     }






    //Jetson 1- Working on port 8080 //********************* tid=0 **********************//
    if(tid==1){
    	struct sockaddr_in serveraddr; /* server's addr */
    	struct sockaddr_in clientaddr; /* client addr */
    	struct hostent *hostp; /* client host info */
    	int sockfd; /* socket */
    	int portno; /* port to listen on */
    	socklen_t clientlen;
    	char *hostaddrp; /* dotted decimal host addr string */
	int optval; /* flag value for setsockopt */
	int n; /* message byte size */
	sockfd = socket(AF_INET, SOCK_DGRAM, 0);
	portno = atoi("1010");
	optval = 1;
	setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval , sizeof(int));
	bzero((char *) &serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr.sin_port = htons((unsigned short)portno);
	int b=bind(sockfd, (struct sockaddr *) &serveraddr, sizeof(serveraddr));
	clientlen = sizeof(clientaddr);
	int buf1[BUFSIZE];
	sleep(1);
	int cc1=0;
	//cout<<"Kernel Thread zero ready to receive..."<<endl;
	while(1)
	{


	    n = recvfrom(sockfd, buf1, BUFSIZE, 0,(struct sockaddr *) &clientaddr, &clientlen);
	   // if(n>0){

	    posX1 = (buf1[0]);
	    posY1 = (buf1[1]);
	    go0.store(true);


	}
	pthread_exit(NULL);
    }

    //Jetson 2- Working on port 9090 //********************* tid=1 **********************//
    if(tid==2){
    	struct sockaddr_in serveraddr2; /* server's addr */
    	struct sockaddr_in clientaddr2; /* client addr */
    	struct hostent *hostp2; /* client host info */
    	int sockfd2; /* socket */
    	int portno2; /* port to listen on */
    	socklen_t clientlen2;
    	char *hostaddrp2; /* dotted decimal host addr string */
	int optval2; /* flag value for setsockopt */
	int n2; /* message byte size */
	sockfd2 = socket(AF_INET, SOCK_DGRAM, 0);
	portno2 = atoi("2020");
	optval2 = 1;
	setsockopt(sockfd2, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval2 , sizeof(int));
	bzero((char *) &serveraddr2, sizeof(serveraddr2));
	serveraddr2.sin_family = AF_INET;
	serveraddr2.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr2.sin_port = htons((unsigned short)portno2);
	int b=bind(sockfd2, (struct sockaddr *) &serveraddr2, sizeof(serveraddr2));
	clientlen2 = sizeof(clientaddr2);
	 int buf2[BUFSIZE];
	sleep(1);
	//cout<<"Kernel Thread one ready to receive..."<<endl;

	while(1)
	{


	    n2 = recvfrom(sockfd2, buf2, BUFSIZE, 0,(struct sockaddr *) &clientaddr2, &clientlen2);
	  //  if(n2>0){
	    posX2 = (buf2[0]);
	    posY2 = (buf2[1]);
	    go1.store(true);




	}
	pthread_exit(NULL);
    }


    if(tid==3){
    	struct sockaddr_in serveraddr3; /* server's addr */
    	struct sockaddr_in clientaddr3; /* client addr */
    	struct hostent *hostp3; /* client host info */
    	int sockfd3; /* socket */
    	int portno3; /* port to listen on */
    	socklen_t clientlen3;
    	char *hostaddrp3; /* dotted decimal host addr string */
	int optval3; /* flag value for setsockopt */
	int n3; /* message byte size */
	sockfd3 = socket(AF_INET, SOCK_DGRAM, 0);
	portno3 = atoi("3030");
	optval3 = 1;
	setsockopt(sockfd3, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval3 , sizeof(int));
	bzero((char *) &serveraddr3, sizeof(serveraddr3));
	serveraddr3.sin_family = AF_INET;
	serveraddr3.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr3.sin_port = htons((unsigned short)portno3);
	int b=bind(sockfd3, (struct sockaddr *) &serveraddr3, sizeof(serveraddr3));
	clientlen3 = sizeof(clientaddr3);
	 int buf3[BUFSIZE];
	sleep(1);
	//cout<<"Kernel Thread one ready to receive..."<<endl;

	while(1)
	{

	    n3 = recvfrom(sockfd3, buf3, BUFSIZE,0,(struct sockaddr *) &clientaddr3, &clientlen3);
	  //  if(n3>0){
	    posX3 = (buf3[0]);
	    posY3 = (buf3[1]);
	    go2.store(true);



	}
	pthread_exit(NULL);
    }


    //GNUplot Working on thread 2 - using System call for running bash //*********** tid2 ************//


  if(tid==4){

	struct sockaddr_in serveraddr4; /* server's addr */
    	struct sockaddr_in clientaddr4; /* client addr */
    	struct hostent *hostp4; /* client host info */
    	int sockfd4; /* socket */
    	int portno4; /* port to listen on */
    	socklen_t clientlen4;
    	char *hostaddrp4; /* dotted decimal host addr string */
	int optval4; /* flag value for setsockopt */
	int n4; /* message byte size */
	sockfd4 = socket(AF_INET, SOCK_DGRAM, 0);
	portno4 = atoi("4040");
	optval4 = 1;
	setsockopt(sockfd4, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval4 , sizeof(int));
	bzero((char *) &serveraddr4, sizeof(serveraddr4));
	serveraddr4.sin_family = AF_INET;
	serveraddr4.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr4.sin_port = htons((unsigned short)portno4);
	int b4=bind(sockfd4, (struct sockaddr *) &serveraddr4, sizeof(serveraddr4));
	clientlen4 = sizeof(clientaddr4);
	 int buf4[BUFSIZE];
	sleep(1);
	//cout<<"Kernel Thread one ready to receive..."<<endl;
	while(1)
	{

	    n4 = recvfrom(sockfd4, buf4, BUFSIZE, 0,(struct sockaddr *) &clientaddr4, &clientlen4);
	  //  if(n4>0){
	    posX4 = (buf4[0]);
	    posY4 = (buf4[1]);
	    go3.store(true);

	    


	}
	pthread_exit(NULL);
     }


  if(tid==5){

	struct sockaddr_in serveraddr5; /* server's addr */
    	struct sockaddr_in clientaddr5; /* client addr */
    	struct hostent *hostp5; /* client host info */
    	int sockfd5; /* socket */
    	int portno5; /* port to listen on */
    	socklen_t clientlen5;
    	char *hostaddrp5; /* dotted decimal host addr string */
	int optval5; /* flag value for setsockopt */
	int n5; /* message byte size */
	sockfd5 = socket(AF_INET, SOCK_DGRAM, 0);
	portno5 = atoi("5050");
	optval5 = 1;
	setsockopt(sockfd5, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval5 , sizeof(int));
	bzero((char *) &serveraddr5, sizeof(serveraddr5));
	serveraddr5.sin_family = AF_INET;
	serveraddr5.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr5.sin_port = htons((unsigned short)portno5);
	int b5=bind(sockfd5, (struct sockaddr *) &serveraddr5, sizeof(serveraddr5));
	clientlen5 = sizeof(clientaddr5);
	 int buf5[BUFSIZE];
	sleep(1);
	//cout<<"Kernel Thread one ready to receive..."<<endl;
	while(1)
	{

	    n5 = recvfrom(sockfd5, buf5, BUFSIZE, 0,(struct sockaddr *) &clientaddr5, &clientlen5);
	   // if(n5>0){
	    posX5 = (buf5[0]);
	    posY5 = (buf5[1]);
	    go4.store(true);
	   // }



	}
	pthread_exit(NULL);
     }
     
     
      if(tid==6){

	struct sockaddr_in serveraddr6; /* server's addr */
    struct sockaddr_in clientaddr6; /* client addr */
    struct hostent *hostp6; /* client host info */
    int sockfd6; /* socket */
    int portno6; /* port to listen on */
    socklen_t clientlen6;
    char *hostaddrp6; /* dotted decimal host addr string */
	int optval6; /* flag value for setsockopt */
	int n6; /* message byte size */
	sockfd6 = socket(AF_INET, SOCK_DGRAM, 0);
	portno6 = atoi("6060");
	optval6 = 1;
	setsockopt(sockfd6, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval6 , sizeof(int));
	bzero((char *) &serveraddr6, sizeof(serveraddr6));
	serveraddr6.sin_family = AF_INET;
	serveraddr6.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr6.sin_port = htons((unsigned short)portno6);
	int b6=bind(sockfd6, (struct sockaddr *) &serveraddr6, sizeof(serveraddr6));
	clientlen6 = sizeof(clientaddr6);
	 int buf6[BUFSIZE];
	sleep(1);
	//cout<<"Kernel Thread one ready to receive..."<<endl;
	while(1)
	{

	    n6 = recvfrom(sockfd6, buf6, BUFSIZE, 0,(struct sockaddr *) &clientaddr6, &clientlen6);
	   // if(n6>0){
	    posX6 = (buf6[0]);
	    posY6 = (buf6[1]);
	    go5.store(true);
	   // }

	    


	}
	pthread_exit(NULL);
     }
     
     
     if(tid==7){
		  

		//set_realtime_priority();
		time_t start,end;
		VideoCapture cap2(CV_CAP_XIAPI+1);
		float gain2=4.0;
		cap2.set(CV_CAP_PROP_XI_AEAG,0);
       		cap2.set(CV_CAP_PROP_XI_EXPOSURE,6000);
       		cap2.set(CV_CAP_PROP_XI_GAIN,gain2);

		int numf=0;
		
		
		if(!cap2.isOpened()){
			cout<<endl<<endl<<"cLOSEUP Camera not connected !!"<<endl<<endl<<endl;
			exit(0) ;
			}
		
		Mat GG; //= Mat::zeros( 1024,1280, CV_8UC1 );
		Mat dst3;
		string mclloc="mkdir "+floc+"/Closeup"; 
		system(mclloc.c_str());
		int cc=0;
		vector<int> CP;
		CP.push_back(CV_IMWRITE_PNG_COMPRESSION);
		CP.push_back(9);
		vector<int> CP2;
		CP2.push_back(CV_IMWRITE_JPEG_QUALITY);
		CP2.push_back(100);
		
		capcon=0;
		time(&start);
		unsigned long mscap,mscap2,mscap3;
		//VideoWriter video("DATAPIC/Live.avi",CV_FOURCC('P','I','M','1'),60,Size(W,H),0);			
		while(1)
		{
			cc=cc+1;
			gettimeofday(&tp3,NULL);
			cap2>>imgcap2;
			resize(imgcap2,dst2,size2);
			imwrite(floc+"/Closeup/IMG_"+ std::to_string(cc)+".jpg",dst2);
			gettimeofday(&tp4,NULL);
			closeupimg=cc;
			

			

		}

	
	}
	
	if(tid==8)
	{
		namedWindow("Feeder", 1);
		usleep(1000000);	
		VideoCapture cap(CV_CAP_XIAPI+0);
		if(!cap.isOpened()){
			cout<<endl<<endl<<"Live Camera not connected !!"<<endl<<endl<<endl;
			exit(0) ;
			}
			
		int numf=0;                                          
		float gain=2.0;
		cap.set(CV_CAP_PROP_XI_AEAG,0);
       	cap.set(CV_CAP_PROP_XI_EXPOSURE,5500);
       	cap.set(CV_CAP_PROP_XI_GAIN,gain);
		cap.set(CV_CAP_PROP_XI_DATA_FORMAT,5);
		int H=cap.get(4);
		int W=cap.get(3);
		
		
		VideoWriter video(floc+"/Live.avi",CV_FOURCC('M','P','E','G'),60,Size(W,H),true);
		
		bb=imread("Feeder.jpg",CV_LOAD_IMAGE_COLOR);
 			
 		
 		createTrackbar("Beep Freq(KHz)","Feeder",&Freq,20);
		createTrackbar("White Noise(s/10)","Feeder",&TT,100);
 		bb.copyTo(img);
		while(1)
		{
			cap>>src;
			
			numf=numf+1;	
			liveimg=numf;
			cvtColor(src,imgcap,COLOR_BayerBG2BGR);
			putText(imgcap,std::to_string(numf),Point(20,1000),FONT_HERSHEY_DUPLEX,1,Scalar(255,255,255));
			video.write(imgcap);
			resize(imgcap,IMG2,size2);

			//imshow("CL",dst2);
			imshow("LIVE",IMG2);
			
			imshow("Feeder",img);
			
			
			freq = static_cast<ostringstream*>( &(ostringstream() << Freq) )->str();
			tt = static_cast<ostringstream*>( &(ostringstream() << TT) )->str();
			
			
			setMouseCallback("Feeder", CallBackFunc, NULL);
			waitKey(1);
			
		}
	
	}
	
	if(tid==9)
	{
		int REWNUM=0;
		
		int change=0;
		usleep(10000000);

		string CMD;
     	int ARDNUM=1;


		FEDPOS[0]=Point3f(-24.640778, 94.499695, 105.68169);
		FEDPOS[1]=Point3f(64.422264, 67.708107, 149.20125);
		FEDPOS[2]=Point3f(79.130646, -19.297955, 61.376152);
		FEDPOS[3]=Point3f(8.3774872, -65.632576, 106.60309);

     	while(1){
     			

	 		
	 			
	 				


			int WT2;
			while(1){
				WT2=int(rand()%MAXARDNUM) +1 ;
				if(ARDNUM!=WT2)break;
	
			}
			ARDNUM=WT2;



	 		cout<<"ARDNUM"<< ARDNUM<<endl;
		 	int sockfd_ard;
			struct addrinfo hints_ard, *servinfo_ard, *p_ard;
			int rv_ard;
			int numbytes_ard;
			memset(&hints_ard, 0, sizeof hints_ard);
			hints_ard.ai_family = AF_UNSPEC;
			hints_ard.ai_socktype = SOCK_DGRAM;
			String ARD="arduino"+std::to_string(WIFLOW[ARDNUM-1]);
			//String ARD="arduino"+std::to_string(3);
			if ((rv_ard = getaddrinfo(ARD.c_str(), SERVERPORTARD, &hints_ard, &servinfo_ard)) != 0) {
				fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv_ard));
			}
			for(p_ard = servinfo_ard; p_ard != NULL; p_ard = p_ard->ai_next) {
				if ((sockfd_ard = socket(p_ard->ai_family, p_ard->ai_socktype,
					p_ard->ai_protocol)) == -1) {
					perror("talker: socket");
					continue;
				}
			break;
			}

	
		 		while(1){
		 		
				 		if(calcdist(POSred,FEDPOS[WIFLOW[ARDNUM-1]-1])>30){
				 			srand(time(NULL));
				 		
				 		
					 		int WT=rand()%60;
					 		cout<<"waiting for "<<WT<<" seconds"<<endl;
					 		usleep(1000000*WT);
					 		
					 		CMD="b9";
							int numbytes = sendto(sockfd_ard,  CMD.c_str(), (CMD.size()), 0, p_ard->ai_addr, p_ard->ai_addrlen);
							
							CMD="p9";
							numbytes = sendto(sockfd_ard,  CMD.c_str(), (CMD.size()), 0, p_ard->ai_addr, p_ard->ai_addrlen);
							
							CMD="b9";
							numbytes = sendto(sockfd_ard,  CMD.c_str(), (CMD.size()), 0, p_ard->ai_addr, p_ard->ai_addrlen);
							
							
							 
							cout<<"CK "<<ARDNUM<<endl;
							click=ARDNUM*1;
							
							gettimeofday(&tpFED1,NULL);
							int rp=0;
					 		while(1)
					 		{

								usleep(1000000);
								
					 			gettimeofday(&tpFED2,NULL);
								unsigned long msFED= 1000000*(tpFED2.tv_sec-tpFED1.tv_sec)+(tpFED2.tv_usec-tpFED1.tv_usec) ;
								if(msFED/1000>30000 ){
									cout<<"NO R"<<endl;
									usleep(10000000);
									break;
									}

								if(calcdist(POSred,FEDPOS[ARDNUM-1])<20){
									CMD="m80";
									int numbytes2 = sendto(sockfd_ard,  CMD.c_str(), (CMD.size()), 0, p_ard->ai_addr, p_ard->ai_addrlen);
									reward=ARDNUM*1;
									cout<<"Got Reward "<<REWNUM<<endl;
									REWNUM=REWNUM+1;
									usleep(1500000);
									while(calcdist(POSred,FEDPOS[ARDNUM-1])<20)
									{}

									break;
								}
								
								

					 		}
					 		break;
				 		}
				 	}
			 	
		 	
			 		
			 	

			 	
			 	
			 	
			 	
			 	
		 }

	}
	
	
	
	if(tid==10)
	{
	
	
		int sockfd;
		struct addrinfo hints, *servinfo, *p;
		int rv;
		int numbytes;

		memset(&hints, 0, sizeof hints);
		hints.ai_family = AF_UNSPEC;
		hints.ai_socktype = SOCK_DGRAM;

		int preARD=ManualARDNUM;
		while(1)
		{
		if(con>0){
			int con2=con;
			if(preARD!=ManualARDNUM)
			{
				 string ARD;
				 ARD="arduino"+std::to_string(ManualARDNUM);
				 //cout<<"hi"<<endl;
				//String ARD="arduino"+std::to_string(3);
				if ((rv = getaddrinfo(ARD.c_str(), SERVERPORTARD, &hints, &servinfo)) != 0) {
					fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
				}
				for(p = servinfo; p != NULL; p = p->ai_next) {
						if ((sockfd = socket(p->ai_family, p->ai_socktype,
							p->ai_protocol)) == -1) {
							perror("talker: socket");
							continue;
						}
					break;
				}
				
				
				preARD=ManualARDNUM;
			}
			
			
			if(1)
			{
				string dd;
				if(con2==1){
					dd="p";
					numbytes = sendto(sockfd,  dd.c_str(), (dd.size()), 0, p->ai_addr, p->ai_addrlen);
				}

				else if(con2==2)
				{

					dd="b";
					dd=(dd+freq).c_str();
					numbytes = sendto(sockfd,  dd.c_str(), (dd.size()), 0, p->ai_addr, p->ai_addrlen);

				}
				else if(con2==3){
				
					dd="w";
					dd=(dd+tt).c_str();
					numbytes = sendto(sockfd,  dd.c_str(), (dd.size()), 0, p->ai_addr, p->ai_addrlen);
				
				

				}
				else if(con2==4){
					dd="m60";
					numbytes = sendto(sockfd,  dd.c_str(), (dd.size()), 0, p->ai_addr, p->ai_addrlen);
				}


				else if(con2==5){
				
					dd="g";
					numbytes = sendto(sockfd,  dd.c_str(), (dd.size()), 0, p->ai_addr, p->ai_addrlen);

				
				}

				else if(con2==6)
				{
				
				dd="i";
				numbytes = sendto(sockfd,  dd.c_str(), (dd.size()), 0, p->ai_addr, p->ai_addrlen);
				}


				con=0;
				gettimeofday(&tpSignal,NULL);
				unsigned long msfeds= 1000000*(tpSignal.tv_sec-tp1.tv_sec)+(tpSignal.tv_usec-tp1.tv_usec) ;
				cout<<dd<<" "<<ManualARDNUM<<endl;
				Signaling<<ManualARDNUM<<" "<<dd<<" "<<msfeds/1000<<endl;
			}
			
		
		
		}
	}
	
	}
	
	
	
	
	
		

	
 
 }

// ************************************************************************** Main Function *************************************************************************************************//



int main(int argc, char **argv) {


	cout<<endl<<endl;
	gettimeofday(&tp1,NULL);
	cout<<"****FEEDERS****"<<endl<<"Please enter the number of feeders"<<endl;
	cin>>MAXARDNUM;
	for(int i=0;i<MAXARDNUM;i++)
		FEDPOS.push_back(Point3f(0,0,0));
		
	cout<<"Enter your feeder numbers"<<endl; 
	for(int i=0;i<MAXARDNUM;i++)
	{
		int fed;
		cin>>fed;
		WIFLOW.push_back(fed);
	}
	
	
	cout<<endl<<"****ANIMAL****"<<endl<<"Please enter the date and animal name:"<<endl;
	
	cin>>floc;
	
	floc= "DATA/"+floc;
	string mloc="mkdir "+floc ;
	system (mloc.c_str());
	string datapath=floc+"/data.txt";
	myfile.open (datapath.c_str());
	string Signalpath=floc+"/FeederSignals.txt";
	Signaling.open (Signalpath);
	myFplot.open ("dataplot.txt");
	
	
	
	
	unsigned long ms2pre;
	   
	cout<<endl<<endl;

    int sockfd;
	struct addrinfo hints, *servinfo, *p;
	int rv;
	int numbytes;
	const char* message="";
	memset(&hints, 0, sizeof hints);
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_DGRAM;
	if ((rv = getaddrinfo("lens", SERVERPORT, &hints, &servinfo)) != 0) {
		fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
		//return 1;
	}
	for(p = servinfo; p != NULL; p = p->ai_next) {
		if ((sockfd = socket(p->ai_family, p->ai_socktype,
		p->ai_protocol)) == -1) {
			perror("talker: socket");
			continue;
	}
		break;
	}

	if (p == NULL) {
		fprintf(stderr, "talker: failed to create socket\n");
	}

       
        // Creating 3 threads
        int rc;
	long tt;
	pthread_t threads[NUM_THREADS];
	cout<<"Creating "<<NUM_THREADS<<" threads"<<endl;
	for(tt=0; tt<NUM_THREADS; tt++){
		//printf("In main: creating thread %ld\n", tt);
		rc = pthread_create(&threads[tt], NULL, Track, (void *)tt);
		if (rc)
	  		printf("ERROR in Creating threads..");

	}
	

	
   	projMatr[0]=mA*M1;
	projMatr[1]=mB*M2;
 	projMatr[2]=mC*M3;
	projMatr[3]=mD*M4;
	projMatr[4]=mE*M5;
	projMatr[5]=mF*M6;
	
  	
	
	//cin>>S;
	int ff=0;
	liveshow=1;
	cout<<endl<<endl<<"*****SERVO*****"<<endl;
	if (portHandler->openPort())
		printf("Servo: Succeeded to open the port!\n");
	else
	{
	   	printf("Servo: Failed to open the port!\n");
	}

	if (portHandler->setBaudRate(BAUDRATE))
	    	printf("Servo: Succeeded to change the baudrate!\n");

	else
	{
	    	printf("Failed to change the baudrate!\n");
	}
	dxl_comm_result = packetHandler->write1ByteTxRx(portHandler, DXL_ID, ADDR_MX_TORQUE_ENABLE, TORQUE_ENABLE, &dxl_error);
	dxl_comm_result2 = packetHandler->write1ByteTxRx(portHandler, DXL_IDD, ADDR_MX_TORQUE_ENABLE, TORQUE_ENABLE, &dxl_error);
	dxl_comm_result = packetHandler->write1ByteTxRx(portHandler, DXL_LID, ADDR_MX_TORQUE_ENABLE, TORQUE_ENABLE, &dxl_error);
	dxl_comm_result2 = packetHandler->write1ByteTxRx(portHandler, DXL_LIDD, ADDR_MX_TORQUE_ENABLE, TORQUE_ENABLE, &dxl_error); 
	if (dxl_comm_result2 != COMM_SUCCESS)
		packetHandler->getTxRxResult(dxl_comm_result);
	else if (dxl_error != 0)
		packetHandler->getRxPacketError(dxl_error);
	else
		printf("Servos: Connected \n");

	cout<<endl<<endl<<endl;
	usleep(5000000);
	cout<<"Tracking started..."<<endl;
	while(1){

		while (!(go0&go1&go2&go3&go4&go5))
		{
			int g=0;
		}
		


		go0=false;
		go1=false;
		go2=false;
		go3=false;
		go4=false;
		go5=false;
		//usleep(3300);

		vector<Point2f> projPoints;
		vector<int> indexxx;

		objA[0].x=posX1;objA[0].y=posY1;
		objB[0].x=posX2;objB[0].y=posY2;
		objC[0].x=posX3;objC[0].y=posY3;
		objD[0].x=posX4;objD[0].y=posY4;
		objE[0].x=posX5;objE[0].y=posY5;
		objF[0].x=posX6;objF[0].y=posY6;
		
		
		undistortPoints(objA, objA_undist, mA, dA);
		undistortPoints(objB, objB_undist, mB, dB);
		undistortPoints(objC, objC_undist, mC, dC);
		undistortPoints(objD, objD_undist, mD, dD);
		undistortPoints(objE, objE_undist, mE, dE);
		undistortPoints(objF, objF_undist, mF, dF);
		
		objA_undist[0].x = objA_undist[0].x* mA.at<float>(0, 0) + mA.at<float>(0, 2);
		objA_undist[0].y = objA_undist[0].y* mA.at<float>(1, 1) + mA.at<float>(1, 2);
		objB_undist[0].x = objB_undist[0].x* mB.at<float>(0, 0) + mB.at<float>(0, 2);
		objB_undist[0].y = objB_undist[0].y* mB.at<float>(1, 1) + mB.at<float>(1, 2);
		objC_undist[0].x = objC_undist[0].x* mC.at<float>(0, 0) + mC.at<float>(0, 2);
		objC_undist[0].y = objC_undist[0].y* mC.at<float>(1, 1) + mC.at<float>(1, 2);
		objD_undist[0].x = objD_undist[0].x* mD.at<float>(0, 0) + mD.at<float>(0, 2);
		objD_undist[0].y = objD_undist[0].y* mD.at<float>(1, 1) + mD.at<float>(1, 2);
		objE_undist[0].x = objE_undist[0].x* mE.at<float>(0, 0) + mE.at<float>(0, 2);
		objE_undist[0].y = objE_undist[0].y* mE.at<float>(1, 1) + mE.at<float>(1, 2);
		objF_undist[0].x = objF_undist[0].x* mF.at<float>(0, 0) + mF.at<float>(0, 2);
		objF_undist[0].y = objF_undist[0].y* mF.at<float>(1, 1) + mF.at<float>(1, 2);


		int xxx=0;
		int ghj=0;


		if(objA[0].x!=0 & objA[0].y!=0)
		{
			xxx=0;indexxx.push_back(xxx);projPoints.push_back(objA_undist[0]);
	
		}
		if(objB[0].x!=0 & objB[0].y!=0)
		{
			xxx=1;indexxx.push_back(xxx);projPoints.push_back(objB_undist[0]);	
			
		}
		if(objC[0].x!=0 & objC[0].y!=0)
		{
			xxx=2;indexxx.push_back(xxx);projPoints.push_back(objC_undist[0]);
	
		}
		if(objD[0].x!=0 & objD[0].y!=0)
		{
			xxx=3;indexxx.push_back(xxx);projPoints.push_back(objD_undist[0]);
	
		}
		
		if(objE[0].x!=0 & objE[0].y!=0)
		{
			xxx=4;indexxx.push_back(xxx);projPoints.push_back(objE_undist[0]);
	
		}
		if(objF[0].x!=0 & objF[0].y!=0)
		{
			xxx=5;indexxx.push_back(xxx);projPoints.push_back(objF_undist[0]);
	
		}


		if(indexxx.size()>1){
			
		
			ff=ff+1;
			
			int NN=Triangulate(projMatr, indexxx,projPoints,P4D);	
			P4Dreal=aff*P4D;
			
			gettimeofday(&tp2,NULL);
			POSred=Point3f( P4Dreal.at<float>(0, 0),P4Dreal.at<float>(0, 1),P4Dreal.at<float>(0, 2));
			
			
			
			
			unsigned long ms2= 1000000*(tp2.tv_sec-tp1.tv_sec)+(tp2.tv_usec-tp1.tv_usec) ;

			
			
			
			
						
			int CLI=click;
			int REWA=reward;
			myfile << P4Dreal.at<float>(0, 0)<<" "<<P4Dreal.at<float>(0, 1)<<" "<<P4Dreal.at<float>(0, 2)<<"  "<<ms2/1000<<"  "<<closeupimg<<" "<<liveimg <<" "<<CLI<<" "<<REWA<<endl;
			if(REWA>0)
				reward=0;
			if(CLI>0)
				click=0;
			myFplot << P4Dreal.at<float>(0, 0)<<" "<<P4Dreal.at<float>(0, 1)<<" "<<P4Dreal.at<float>(0, 2)<<endl;
			globalplot=1;
			
			
			
			
			
			
			
			x=P4Dreal.at<float>(0, 0)-(-21.16);
			y=P4Dreal.at<float>(0, 1)-(-164);
			z=P4Dreal.at<float>(0, 2)-(234.6);
			AA=(float(x)/float(y));
			A=float(atan(AA))*(180/M_PI);
			A=float(float(A)/0.087);
			AF=int(A)+1975;
			shit=float(x)*float(x)+float(y)*float(y);
			shit=float(sqrt(shit));
			BB=(float(z)/float(shit));
			B=float(atan(BB))*(180/M_PI);
			B=float(float(B)/0.087);
			BF=-int(B)+1930;
			
			
			CC=float(x)*float(x)+float(y)*float(y)+float(z)*float(z);
			GG=(99.78/float(sqrt(CC)))+0.96+0.07;
			//cout<<GG<<endl;
		//	cin>>GG;
			ostringstream convert;
			convert << "RS1," << GG;
			const char* message=(convert.str().c_str());
			size_t msg_l=strlen(message);
			sendto(sockfd, message, msg_l, 0, p->ai_addr, p->ai_addrlen);


			x=P4Dreal.at<float>(0, 0)-(-3);
			y=P4Dreal.at<float>(0, 1)-(-123);
			z=P4Dreal.at<float>(0, 2)-(237.6);
			float Dis=5.5;
			float D1,Dp;
			AA2=(float(x)/float(y));
			A2=float(atan(AA2))*(180/M_PI);
			//cout<<A2<<" "<<(90-OFD)<<endl;
			D1=float(x)*float(x)+float(y)*float(y);
			OFD=acos(float(Dis)/float(sqrt(D1)))*(180/M_PI);
			A2=A2+(90-OFD);
			
			A2=float(float(A2)/0.087);
			AF2=int(A2)+2335;
			BB2=(float(z)/float(sqrt(D1-Dis*Dis)));
			B2=float(atan(BB2))*(180/M_PI);
			B2=float(float(B2)/0.087);
			BF2=-int(B2)+1870;
			//cin>>AF2;
			//cin>>BF2;
			
			param_goal_position[0] = DXL_LOBYTE(AF);
    			param_goal_position[1] = DXL_HIBYTE(AF);
    			param_goal_position2[0] = DXL_LOBYTE(BF);
    			param_goal_position2[1] = DXL_HIBYTE(BF);
    			
    			//cin>>AF2;
    			//cin>>BF2;
    			param_goal_Lposition[0] = DXL_LOBYTE(AF2);
    			param_goal_Lposition[1] = DXL_HIBYTE(AF2);
    			param_goal_Lposition2[0] = DXL_LOBYTE(BF2);
    			param_goal_Lposition2[1] = DXL_HIBYTE(BF2);
			dxl_addparam_result = groupSyncWrite.addParam(DXL_ID, param_goal_position);
			dxl_addparam_result = groupSyncWrite.addParam(DXL_IDD, param_goal_position2);
			dxl_addparam_result = groupSyncWrite.addParam(DXL_LID, param_goal_Lposition);
			dxl_addparam_result = groupSyncWrite.addParam(DXL_LIDD, param_goal_Lposition2);
			if((BF<3000 & BF>1400) & (AF<3672 & AF>924) & P4Dreal.at<float>(0, 1) > -110)
				dxl_comm_result = groupSyncWrite.txPacket();
			
			groupSyncWrite.clearParam();
		

			
			
			starttr=1;

	    	}
		
			

	}
	
	return 0;
		


        }



       
        



